/****************************************************************************/
/**   vjbox  Hier stehen die einzelnen Befehle drin                        **/
/**                                                                        **/
/** Copyright (C) 1997 Jochen Tillmann-Sarrazin, DG6VJ                     **/
/** All rights reserved.                                                   **/
/****************************************************************************/

#include "global.h"


typedef struct s_rublist {
  struct s_rublist *next;
  char *rubrik;
} s_rublist;


char str_must_login[] = "002 You must log in to use this command (use the LOGIN-Cmd).\n";
char str_must_pass[] = "003 PASS-Cmd required\n";
char monate[12][4]={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

int is_in_pass_cmd=0;

#define ANZ_COMMANDS 22
char Commands[ANZ_COMMANDS][20] = {"QUIT",
                                   "LOGIN",
                                   "VERSION",
                                   "PUTMAIL",
                                   "NEWMAIL",
                                   "GETMAIL",
                                   "HEADER",
                                   "MYBBS",
                                   "READLOCK",
                                   "MSG",
                                   "BOARDLIST",
                                   "GETINFO",
                                   "NAME",
                                   "READ",
                                   "LIST",
                                   "PASS",
                                   "SHOWLOGINS",
                                   "PUT",
                                   "CALLVALID",
                                   "DELETEBID",
                                   "CONFIG",
                                   "BIDEXIST"};



/*
 * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
 * wurde.
 */
int global_command_tests()
{
  /* Der User mu eingeloggt sein */
  if (!logged_in) {
    write(child_fd,str_must_login,strlen(str_must_login));
    return(FALSE);
  }
  
  /* Und er darf sich nicht im Pass-Befehl befinden */
  if (is_in_pass_cmd)
  {
    write(child_fd,str_must_pass,strlen(str_must_pass));
    return(FALSE);
  }
  
  return(TRUE);
}




int what_command(char *str, char *param)
{
  int i;



  /* Ein evtl. vorhandenes \n lschen. */
  if ((i = POS('\n',str)) != -1) str[i] = '\0';
  if ((i = POS('\r',str)) != -1) str[i] = '\0';
  
  
  
  if ((i = POS(' ',str)) == -1) {
    /* Keine Parameter vorhanden - param leer machen */
    param[0] = '\0';
  }
  else {
    /* Sooo... die Parameter nach param schreiben */
    COPY(param,str,i+1,strlen(str)-i-1);
    
    str[i] = '\0';
  }
  
  Gross(str);
  
  
  i = 0;
  while (i < ANZ_COMMANDS) {
    if (!strcmp(str,Commands[i]))
       return(i);
    else
       i++;
  }
  
  return(-1);
}





void cmd_quit()
{

  if (logged_in) {
    child_udata.anzlogins++;
    child_udata.lastquit = child_udata.lastlogin;
    WriteUserData(&child_udata);
  }

  ChildTerminate();
}




/* Ein User loggt sich ein. */
void cmd_login(char *param)
{
  char str[500],md2prompt[100],expect_pw[100];

  char str_access_denied[] = "103 Sorry, access denied.\n";

  KillSpacesRight(param);
  KillSpacesLeft(param);
  
  if (param[0] == '\0') {
    strcpy(str,"103 Sorry, access denied.\n");
    write(child_fd,str,strlen(str));
    ChildTerminate();
    return;
  }

  /* Rufzeichen klein machen */
  Klein(param);
  
  clear_udata(&child_udata);
  strcpy(child_udata.call,param);
  
  /* Gucken, ob dieser User im badcalls-File ist */
  if (is_in_badcalls(child_udata.call) == 1) {
    write(child_fd,str_access_denied,strlen(str_access_denied));
    ChildTerminate();
    return;
  }

  /* Userdaten aus der Datenbank holen */
  GetUserData(&child_udata);


  if (strlen(child_udata.passwd) <= 20) {
    sprintf(str,"101 %s%s vjboxd-%i.%i.%i\n",mycall,myhierarch,MAJORLEVEL,MINORLEVEL,PATCHLEVEL);
    write(child_fd,str,strlen(str));

    child_udata.expect_pw[0] = '\0';
  }
  else {
  
    calc_MD2_prompt(md2prompt);
  
    sprintf(str,"101 %s%s vjboxd-%i.%i.%i [%s]\n",mycall,myhierarch,MAJORLEVEL,MINORLEVEL,PATCHLEVEL,md2prompt);
    write(child_fd,str,strlen(str));
  
    /* Passwort berechnen */
    calc_MD2_pw(md2prompt,child_udata.passwd,child_udata.expect_pw);

    return;
  }

  /* nderungen (loginzeit) machen, und die Daten wieder zurck schreiben */
  child_udata.lastlogin = time(NULL);
  WriteUserData(&child_udata);
  
  logged_in = TRUE;
  
  /* Das aktuelle Userfile ist das eigene */
  strcpy(aktbox,child_udata.call);
  /* Deshalb ist der Readlock-Eintrag auch vllig wurscht. */
  aktbox_readlock = child_udata.readlock;
  
  /* Nach erfolgtem Einloggen werden ein paar Informationen, die wir ber den User
   * gespeichert haben, 'rausgeschickt.
   */
  if (child_udata.lastmybbs != 0) {
    sprintf(str,"mybbs %s (%i)\n",child_udata.mybbs,child_udata.lastmybbs);
    write(child_fd,str,strlen(str));
  }
  sprintf(str,"readlock %i\n",child_udata.readlock);
  write(child_fd,str,strlen(str));
  if (child_udata.friends[0] != '\0') {
    sprintf(str,"readlock-friends %s\n",child_udata.friends);
    write(child_fd,str,strlen(str));
  }
  if (child_udata.name[0] != '\0') {
    sprintf(str,"name %s\n",child_udata.name);
    write(child_fd,str,strlen(str));
  }
  sprintf(str,"lastlogin %i\nlastquit %i\n",child_udata.lastlogin,child_udata.lastquit);
  write(child_fd,str,strlen(str));


  strcpy(str,".\n");
  write(child_fd,str,strlen(str));

  fuelle_pidfile();
}




void cmd_pass(char *param)
{
  char str[500],tmp[500];

  if (param[0] == '\0') {
    strcpy(str,"103 Sorry, access denied.\n");
    write(child_fd,str,strlen(str));
    ChildTerminate();
    return;
  }

  if (strcmp(param,child_udata.expect_pw)) {
    /* Gesendetes Passwort stimmt nicht mit dem selbst berechneten berein */
    strcpy(str,"103 Sorry, access denied.\n");
    write(child_fd,str,strlen(str));
    ChildTerminate();
    return;
  }

  child_udata.expect_pw[0] = '\0';

  /* nderungen (loginzeit etc) machen, und die Daten wieder zurck schreiben */
  child_udata.lastlogin = time(NULL);
  WriteUserData(&child_udata);
  
  logged_in = TRUE;
  
  /* Das aktuelle Userfile ist das eigene */
  strcpy(aktbox,child_udata.call);
  /* Deshalb ist der Readlock-Eintrag auch vllig wurscht. */
  aktbox_readlock = child_udata.readlock;
  
  /* Nach erfolgtem Einloggen werden ein paar Informationen, die wir ber den User
   * gespeichert haben, 'rausgeschickt.
   */
  if (child_udata.lastmybbs != 0) {
    sprintf(str,"mybbs %s (%i)\n",child_udata.mybbs,child_udata.lastmybbs);
    write(child_fd,str,strlen(str));
  }
  sprintf(str,"readlock %i\n",child_udata.readlock);
  write(child_fd,str,strlen(str));
  if (child_udata.friends[0] != '\0') {
    sprintf(str,"readlock-friends %s\n",child_udata.friends);
    write(child_fd,str,strlen(str));
  }
  if (child_udata.name[0] != '\0') {
    sprintf(str,"name %s\n",child_udata.name);
    write(child_fd,str,strlen(str));
  }
  sprintf(str,"lastlogin %i\nlastquit %i\n",child_udata.lastlogin,child_udata.lastquit);
  write(child_fd,str,strlen(str));


  strcpy(str,".\n");
  write(child_fd,str,strlen(str));

  fuelle_pidfile();


}



/* Kurze Versions-Information der Mailbox */
void cmd_version()
{
  char tmp[500];
  struct tm tm_broke;
  time_t timediff;
  struct tm_diff tm_difference;
  
  strcpy(tmp,"121 Versions-Informationen vjboxd:\n");
  write(child_fd,tmp,strlen(tmp)),
  
  sprintf(tmp,"vjboxd V%i.%i.%i (%s)\nCopyright (C) 1997 Jochen Sarrazin, DG6VJ <sarrazin@muenster.de>\n",
              MAJORLEVEL,MINORLEVEL,PATCHLEVEL,DATUM);
  write(child_fd,tmp,strlen(tmp)),
  
  /* Uptime */
  tm_broke = *gmtime(&startuptime);
  sprintf(tmp,"running since %.2d.%.2d.%.2d %.2d:%.2d",
          tm_broke.tm_mday,tm_broke.tm_mon+1,tm_broke.tm_year,tm_broke.tm_hour,tm_broke.tm_min);
  write(child_fd,tmp,strlen(tmp));
  
  timediff = time(NULL) - startuptime;
  GetTimeDiff(&tm_difference,timediff);
  sprintf(tmp," (%d days, %d hours, %d minutes, %d seconds)\n",
          tm_difference.days, tm_difference.hours, tm_difference.mins, tm_difference.secs);
  write(child_fd,tmp,strlen(tmp));
  
  /* Wieviele Server sind online? */
  sprintf(tmp,"%i mailserver available.\n",get_mailservercount());
  write(child_fd,tmp,strlen(tmp));




  strcpy(tmp,".\n");
  write(child_fd,tmp,strlen(tmp));
}




/* Ein User verschickt eine Mail */
void cmd_putmail(char *param)
{
  char rubrik[10];
  char mbx[10];
  int lt,i,getlen=0,len=0,usermail,len_got=0,fd,count,ende=0,idxnr,maxlt;
  char tmp[500],tmp2[500];
  char bid[13],subject[81];
  time_t tnow;
  struct tm gm_tnow;
  s_check checkdata;
  s_index indexdata;
  char transfer_rubrik[9];
  int new_lt,transfer=FALSE;
  
  char str_put_error[] = "111 Syntax error.\n";
  
  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;
  
  if ((i = POS(' ',param)) == -1) {
    write(child_fd,str_put_error,strlen(str_put_error));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  tmp[10] = '\0';
  strcpy(rubrik,tmp);
  
  if ((i = POS(' ',param)) == -1) {
    write(child_fd,str_put_error,strlen(str_put_error));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  tmp[10] = '\0';
  strcpy(mbx,tmp);

  Klein(rubrik);
  Klein(mbx);

  /* Wenn das eine Einbuchstaben-Rubrik ist, wird geguckt, ob dieser User berhaupt in
   * eine solche Rubrik schreiben darf...
   */
  if (strlen(rubrik) == 1) {
    if ((child_udata.flags & UDATA_SYSOP) != UDATA_SYSOP) {
      strcpy(tmp,"115 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }
  
  if ((i = POS(' ',param)) == -1) {
    /* Nur Lifetime */
    lt = atoi(param);
  }
  else {
    getlen = 1;
    COPY(tmp,param,0,i);
    COPY(param,param,i+1,strlen(param)-i-1);
    
    lt = atoi(tmp);
    len = atoi(param);
  }
  
  /* Fr diese Mail eine neue BID erzeugen */
  NewBID(bid);
  Gross(bid);


  /* Kommt da eine Usermail? */
  if (rufz(rubrik))
     usermail = TRUE;
  else
     usermail = FALSE;

  if (!strcmp(mbx,"?")) {
    /* Kein Verteiler bekannt. Bei Pub-Mails den Standardverteiler, bei Usermails das MYBBS
     * 'raussuchen.
     */
    if (usermail) {
      if (!get_mybbs(rubrik,mbx)) {
        /* Das bergebene Rufzeichen ist unbekannt */
        strcpy(tmp,"117 Unknown destination-box.\n");
        write(child_fd,tmp,strlen(tmp));
        return;
      }
      Klein(mbx);
    }
    else {
      /* Der Verteiler ist die eigene Mailbox. */
      strcpy(mbx,mycall);
      Klein(mbx);
    }
  }



  /* Nur in boards.box gucken, wenn es ein Bulletin ist. */
  if (!usermail) {
    /* Gucken, ob diese Mail evtl. im boards.box - File steht (transfer) */
    if (get_boardinfo(rubrik,&new_lt,&maxlt,transfer_rubrik)) {
      /* Ja, vorhanden. Nach der Lifetime gucken */
      if (lt == -1) lt = new_lt;
      if (lt > (maxlt)) lt = maxlt;
    
      /* Transfer */
      strcpy(rubrik,transfer_rubrik);
    }
    else {
      /* Nicht vorhanden im boards.box - File */
      if (lt == -1) lt = stdlt;
    }
  }
  else {
    if (lt == -1) lt = userlt;
    if (lt > userlt) lt = userlt;
  }


  
  /* Gucken, ob das Datenverzeichnis fr diese Rubrik schon existiert */
  if (usermail)
     sprintf(tmp,"%s/user/%s",boxroot,rubrik);
  else
     sprintf(tmp,"%s/info/%s",boxroot,rubrik);
  if (mkdir(tmp,448) == -1) { }
  
  /* File ffnen. */
  sprintf(tmp,"%s/%s",tmp,bid);
  fd = open(tmp,(O_WRONLY|O_CREAT));
  fchmod(fd,(S_IRUSR|S_IWUSR));
  
  strcpy(tmp,"112 Waiting for the subject.\n");
  write(child_fd,tmp,strlen(tmp));
  
  
  /* Warten auf das Subject */
  count = child_getline(tmp,sizeof(tmp));
  tmp[81] = '\0';
  strcpy(subject,tmp);
  if ((i = POS('\n',subject)) != -1) subject[i] = '\0';
  if ((i = POS('\r',subject)) != -1) subject[i] = '\0';
  
  /* "RFC"-Header in das File schreiben */
  sprintf(tmp,"Path: %s\n",mycall);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Read: %256c\n",' ');
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"From: %s@%s%s\n",child_udata.call,mycall,myhierarch);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"To: %s@%s\n",rubrik,mbx);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Subject: %s\n",subject);
  write(fd,tmp,strlen(tmp));
  
  tnow = time(NULL);
  gm_tnow = *gmtime(&tnow);
  sprintf(tmp,"Date: %i %s %i %.2i:%.2i:%.2i\n",gm_tnow.tm_mday,monate[gm_tnow.tm_mon],gm_tnow.tm_year+1900,
                                              gm_tnow.tm_hour,gm_tnow.tm_min,gm_tnow.tm_sec);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Message-ID: %s\n",bid);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Lifetime: %i\n",lt);
  write(fd,tmp,strlen(tmp));

  /* Sooo - jetzt mit einem \n getrennt kommt der aus dem Amateurfunk bekannte header */
  sprintf(tmp,"\n");
  sprintf(tmp2,"%s%s",mycall,myhierarch);
  Gross(tmp2);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"R:%.2i%.2i%.2i/%.2i%.2iZ @:%s [%s] vjboxd-%i.%i\n",
              gm_tnow.tm_year,gm_tnow.tm_mon+1,gm_tnow.tm_mday,gm_tnow.tm_hour,gm_tnow.tm_min,
              tmp2,sfinfo,MAJORLEVEL,MINORLEVEL);
  write(fd,tmp,strlen(tmp));
  
  sprintf(tmp2,"%s @ %s%s",child_udata.call,mycall,myhierarch);
  Gross(tmp2);
  if (child_udata.name[0] != '\0')
     sprintf(tmp,"From: %s (%s)\n",tmp2,child_udata.name);
  else
     sprintf(tmp,"From: %s\n",tmp2);
  write(fd,tmp,strlen(tmp));
  
  
  sprintf(tmp2,"%s @ %s",rubrik,mbx);
  Gross(tmp2);
  sprintf(tmp,"To:   %s\n\n",tmp2);
  write(fd,tmp,strlen(tmp));

  /* Dem Frontend bescheid sagen, da empfangen wird */
  if (getlen)
     sprintf(tmp,"114 OK, waiting for %i bytes.\n",len);
  else
     sprintf(tmp,"113 OK, end with a single dot.\n");
  write(child_fd,tmp,strlen(tmp));
  ende = 0;
  
  while (!ende) {
    count = child_getline(tmp,sizeof(tmp));
    tmp[81] = '\0';
    
    if (getlen) {
      if (len_got+count <= len) {
        write(fd,tmp,count);
        len_got = len_got + count;
      }
      else {
        ende = 1;
        write(fd,tmp,len-len_got);
      }
    }
    else {
      if ((count <= 3) && (tmp[0] == '.'))
         ende = 1;
      else {
        write(fd,tmp,count);
        len = len + count;
      }
    }
  }
  
  
  close(fd);

  /* Den Eintrag ins Index-File machen */
  strcpy(indexdata.mbx,mbx);
  strcpy(indexdata.sender,child_udata.call);
  indexdata.date = tnow;
  indexdata.len = len;
  indexdata.lt = lt;
  indexdata.read = 0;
  strcpy(indexdata.bid,bid);
  strcpy(indexdata.subject,subject);
  if (!usermail)
     indexdata.flags = 0;
  else
     indexdata.flags = MAIL_USER;
  switch (hold_this_msg(indexdata.sender,rubrik,indexdata.mbx,indexdata.len,usermail)) {
    case 1: /* HOLD */
            indexdata.flags |= MAIL_HOLD;
            break;
    case 2: /* REJECT */
            break;
  }
  idxnr = write_index(&indexdata,rubrik);

  /* Den Eintrag in die Checkliste machen */
  strcpy(checkdata.rubrik,rubrik);
  strcpy(checkdata.mbx,mbx);
  strcpy(checkdata.sender,child_udata.call);
  checkdata.date = indexdata.date;
  checkdata.len = indexdata.len;
  checkdata.lt = indexdata.lt;
  checkdata.flags = indexdata.flags;
  checkdata.nr = idxnr;
  checkdata.read = 0;			/* Anzahl Read-Zugriffe auf diese Mail */
  strcpy(checkdata.bid,bid);
  strcpy(checkdata.subject,subject);
  write_checklist(&checkdata);
  
  
  /* diese BID zur BID-Liste dazu */
  add_bidlist(bid);

  /* Sendet diese (neue) BID in Richtung Router */
  router_sendbid_fifo(bid);

  /* anzsend++ */
  child_udata.anzsend++;
  WriteUserData(&child_udata);
  
  sprintf(tmp,"116 OK, file saved.\n");
  write(child_fd,tmp,strlen(tmp));
  
}



/* Guckt, ob die angegebene Rubrik in der verketteten Liste vorhanden ist. Wenn ja
 * wird 1 zurck gegeben, wenn nein 0
 */
int isgroup(char *rub, s_rublist *list)
{
  s_rublist *tmp;
  char rubrik[9];
  
  strcpy(rubrik,rub);
  Gross(rubrik);
  
  tmp = list;
  while (tmp != NULL) {
    if (!strcmp(tmp->rubrik,rubrik)) return(1);
    if (tmp->rubrik[0] == '*') return(1);
    tmp = tmp->next;
  }
  return(0);
}


void cmd_newmail(char *param)
{
  char tmp[500];
  time_t rxtime;
  int i,ready,fd,ans_long=FALSE,ans_all=FALSE,ok;
  s_rublist *getlist,*rejlist,*tmplist;
  long size,akt;
  s_check check;


  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;
  
  
  getlist = NULL;
  rejlist = NULL;
  
  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';
  
  
  if ((i = POS(' ',param)) == -1) {
    strcpy(tmp,"131 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  rxtime = atoi(tmp);
  
  /* Gucken, ob nach param noch das Schlsselwort long kommt */
  if ((i = POS(' ',param)) != -1) {
    /* Ja, da kommt noch was */
    COPY(tmp,param,i+1,strlen(param)-i-1);
    param[i] = '\0';
    Klein(tmp);
    if (!strcmp(tmp,"long"))
       ans_long = TRUE;
    else
       if (!strcmp(tmp,"all")) {
         ans_all = TRUE;
         ans_long = TRUE;
       }
       else { 
         strcpy(tmp,"131 Syntax error.\n");
         write(child_fd,tmp,strlen(tmp));
         return;
       }
  }
  
  Gross(param);
  
  /* In Param steht jetzt drin, welche Rubriken gewnscht werden, z.B. "*,!meinung" oder
   * "darc,sat-tv". Die einzelnen Rubriken werden in die Listen getlist und rejlist ein-
   * getragen.
   */
  while (param[0] != '\0') {
    if ((i = POS(',',param)) == -1) {
      strcpy(tmp,param);
      param[0] = '\0';
    }
    else {
      COPY(tmp,param,0,i);
      COPY(param,param,i+1,strlen(param)-i-1);
    }
    
    if (tmp[0] == '!') {
      COPY(tmp,tmp,1,strlen(tmp)-1);
    
      /* Diese Rubrik will der Client nicht haben */
      tmplist = rejlist;
      
      if (tmplist == NULL) {
        tmplist = (s_rublist *)malloc(sizeof(s_rublist));
        rejlist = tmplist;
      }
      else {
        while (tmplist->next != NULL) tmplist = tmplist->next;
        tmplist->next = (s_rublist *)malloc(sizeof(s_rublist));
        tmplist = tmplist->next;
      }
    }
    else {
      /* Diese Rubrik will der Client haben */
      tmplist = getlist;

      if (tmplist == NULL) {
        tmplist = (s_rublist *)malloc(sizeof(s_rublist));
        getlist = tmplist;
      }
      else {
        while (tmplist->next != NULL) tmplist = tmplist->next;
        tmplist->next = (s_rublist *)malloc(sizeof(s_rublist));
        tmplist = tmplist->next;
      }
    }
    tmplist->next = NULL;
    tmplist->rubrik = (char *)strdup(tmp);
  }


  strcpy(tmp,"132 New mail follows:\n");
  write(child_fd,tmp,strlen(tmp));

  /* File ffnen */  
  sprintf(tmp,"%s/system/check.dat",boxroot);
  if ((fd = open(tmp,O_RDONLY)) != -1) {
    
    /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
    lockit(fd,F_RDLCK,0,SEEK_SET,0);
    
    akt = 1;
    ready = 0;
    
    while (!ready) {
      if (lseek(fd,-sizeof(s_check)*akt,SEEK_END) == -1) {
        /* Wir sind am Anfang des Files angelangt */
        ready = 1;
      }
      else {
        if (read(fd,&check,sizeof(s_check)) != sizeof(s_check)) {
          /* Fehler beim Lesen - sollte eigentlich nicht auftreten */
          ready = 1;
        }
        else {
          if (check.date < rxtime) {
            /* Da das checkfile zeitlich sortiert ist, kommen jetzt nur noch alte Mails */
            ready = 1;
          }
          else if ((isgroup(check.rubrik,getlist)) && (!isgroup(check.rubrik,rejlist))) {
                 if (ans_all || ((check.flags & MAIL_USER) == 0)) {
                   
                   ok = FALSE;
                   
                   /* Wenn die Mail zum Hold eingetragen ist, darf sie nur der Absender und
                    * der SysOp  lesen.
                    */
                   if ((check.flags & MAIL_HOLD) == MAIL_HOLD) {
                     /* SysOp? */
                     if ((child_udata.flags & UDATA_SYSOP) == UDATA_SYSOP) ok = TRUE;
                     /* Absender? */
                     if (!strcmp(child_udata.call,check.sender)) ok = TRUE;
                   }
                   else ok = TRUE;
                   
                   /* Einbuchstabenrubrik & nicht SysOp? */
                   if ((strlen(check.rubrik)==1) && ((child_udata.flags & UDATA_SYSOP) == 0)) ok = FALSE;

                   /* Wenn sie schon gelscht wurde, darf sie niemand mehr lesen */
                   if ((check.flags & MAIL_DEL) == MAIL_DEL) ok = FALSE;
                   
                   if (ok) {
                     sprintf(tmp,"%s\n",check.bid);
                     write(child_fd,tmp,strlen(tmp));
                     if (ans_long) {
                       if ((check.flags & MAIL_HOLD) == MAIL_HOLD)
                          sprintf(tmp," %s %s %s %i %i %i %i H\n"
                                     ,check.rubrik,check.mbx,check.sender,check.date,check.len,check.lt,check.nr);
                       else
                          sprintf(tmp," %s %s %s %i %i %i %i\n"
                                     ,check.rubrik,check.mbx,check.sender,check.date,check.len,check.lt,check.nr);                        write(child_fd,tmp,strlen(tmp));
                       sprintf(tmp," %s\n",check.subject);
                       write(child_fd,tmp,strlen(tmp));
                     }
                   }
                 }
               }
        }
      }
      akt++;
    }
    
    /* File unlocken */
    lockit(fd,F_UNLCK,0,SEEK_SET,0);
    
    close(fd);
  }
  
  /* Am Ende - '.' schicken */
  strcpy(tmp,".\n");
  write(child_fd,tmp,strlen(tmp));

  /* Den Speicher der verketteten Listen wieder freigeben */ 
  while (getlist != NULL) {
    tmplist = getlist;
    getlist = getlist->next;
    free(tmplist);
  }
  while (rejlist != NULL) {
    tmplist = rejlist;
    rejlist = rejlist->next;
    free(tmplist);
  }
}




/* Eine Mail anhand ihrer BID auslesen */
void cmd_getmail(char *param)
{
  int fd,count;
  char tmp[500],filename[500];
  int i,ok,rl;
  s_check check;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;


  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';
  
  
  if (param[0] == '\0') {
    strcpy(tmp,"141 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  if (getinfo_bid(param,&check) == 0) {
    /* Die BID ist nicht bekannt. */
    sprintf(tmp,"142 Unknown BID %s.\n",param);
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  
  /* Wenn das eine Einbuchstaben-Rubrik ist, wird geguckt, ob dieser User berhaupt in
   * eine solche Rubrik schreiben darf...
   */
  if (strlen(check.rubrik) == 1) {
    if ((child_udata.flags & UDATA_SYSOP) != UDATA_SYSOP) {
      strcpy(tmp,"144 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }


  /* Bei Usermails: Gucken, ob die Mail berhaupt gelesen werden darf. */
  Klein(check.rubrik);
  if ((check.flags & MAIL_USER) == MAIL_USER) {
    rl = get_readlock(check.rubrik,NULL);
    if (!readpermission(check.flags,check.rubrik,rl)) {
      strcpy(tmp,"144 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }


  /* HOLD fr diese Mail aktiv? */
  if ((check.flags & MAIL_HOLD) == MAIL_HOLD) {
    if (((child_udata.flags & UDATA_SYSOP) == 0) && (strcmp(check.sender,child_udata.call) != 0)) {
      strcpy(tmp,"144 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }


  /* Gucken, ob die Mail gelscht wurde */
  if ((check.flags & MAIL_DEL) == MAIL_DEL) {
    /* Ja - Fehlermeldung */
    strcpy(tmp,"146 Mail is deleted.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  if ((check.flags & MAIL_USER) == 0)
     sprintf(filename,"%s/info/%s/%s",boxroot,check.rubrik,param);
  else
     sprintf(filename,"%s/user/%s/%s",boxroot,check.rubrik,param);
  if ((fd = open(filename,O_RDONLY)) == -1) {
    strcpy(tmp,"145 Datafile not available\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
  lockit(fd,F_RDLCK,0,SEEK_SET,0);

  sprintf(tmp,"143 BID %s follows:\n",param);
  write(child_fd,tmp,strlen(tmp));

  /* ReadCount-Zeile ausgeben */
  sprintf(tmp,"Readcount: %i\n",check.read);
  write(child_fd,tmp,strlen(tmp));

  while ((count = read(fd,tmp,250)) != 0)
      write(child_fd,tmp,count);

  /* File unlocken */
  lockit(fd,F_UNLCK,0,SEEK_SET,0);
  
  close(fd);
  
  /* Lese-Zhler um 1 erhhen */
  inc_readcount(param,check.rubrik);
 
  /* Rufzeichen in die Readzeile anhngen */
  add_readlist(filename,child_udata.call);
    
  strcpy(tmp,"\n.\n");
  write(child_fd,tmp,strlen(tmp));
}



void cmd_header(char *param)
{
  int fd,count;
  char tmp[500];
  int i,rl;
  FILE *fs;
  s_check check;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;
  
  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';
  
  
  if (param[0] == '\0') {
    strcpy(tmp,"151 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  if (getinfo_bid(param,&check) == 0) {
    /* Die BID ist nicht bekannt. */
    sprintf(tmp,"152 Unknown BID %s.\n",param);
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  
  /* Wenn das eine Einbuchstaben-Rubrik ist, wird geguckt, ob dieser User berhaupt in
   * eine solche Rubrik schreiben darf...
   */
  if (strlen(check.rubrik) == 1) {
    if ((child_udata.flags & UDATA_SYSOP) != UDATA_SYSOP) {
      strcpy(tmp,"154 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }
  
  /* Bei Usermails: Gucken, ob die Mail berhaupt gelesen werden darf. */
  if ((check.flags & MAIL_USER) == MAIL_USER) {
    rl = get_readlock(check.rubrik,NULL);
    if (!readpermission(check.flags,check.rubrik,rl)) {
      strcpy(tmp,"154 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }


  /* HOLD fr diese Mail aktiv? */
  if ((check.flags & MAIL_HOLD) == MAIL_HOLD) {
    if (((child_udata.flags & UDATA_SYSOP) == 0) && (strcmp(check.sender,child_udata.call) != 0)) {
      strcpy(tmp,"154 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }

  /* Gucken, ob die Mail gelscht wurde */
  if ((check.flags & MAIL_DEL) == MAIL_DEL) {
    /* Ja - Fehlermeldung */
    strcpy(tmp,"156 Mail is deleted.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }


  Klein(check.rubrik);
  if ((check.flags & MAIL_USER) == 0)
     sprintf(tmp,"%s/info/%s/%s",boxroot,check.rubrik,param);
  else
     sprintf(tmp,"%s/user/%s/%s",boxroot,check.rubrik,param);
  if ((fd = open(tmp,O_RDONLY)) == -1) {
    strcpy(tmp,"155 Datafile not available\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  else {
  
    /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
    lockit(fd,F_RDLCK,0,SEEK_SET,0);
    
    sprintf(tmp,"153 BID %s follows:\n",param);
    write(child_fd,tmp,strlen(tmp));
    
    fs = fdopen(fd,"r");
    
    i = 0;
    while (!i) {
      if (fgets(tmp,500,fs) == NULL)
         i = 1;
      else
         if (tmp[0] == '\n') i = 1;
      if (i == 0) write(child_fd,tmp,strlen(tmp));
    }
    
    /* File unlocken */
    lockit(fd,F_UNLCK,0,SEEK_SET,0);
    
    close(fd);
    
    strcpy(tmp,".\n");
    write(child_fd,tmp,strlen(tmp));
  }
}





/* Wechselt das aktuelle Userfile */
/*void cmd_changebox(char *call)
{
  int rl,ok,i,mailcount;
  char friends[100],tmp[500];

  /* Gucken, ob der User berhaupt eingeloggt ist */
/*  if (!logged_in) {
    write(child_fd,str_must_login,strlen(str_must_login));
    return;
  }
  if ((i = POS('\n',call)) != -1) call[i] = '\0';
  if ((i = POS('\r',call)) != -1) call[i] = '\0';

  if (call[0] == '\0') {
    strcpy(tmp,"211 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  call[9] = '\0';
  Klein(call);

  /* Gucken, ob diese Station einen Readlock gesetzt hat */
/*  rl = get_readlock(call,friends);

  /* Existiert denn das zugehrige Index-File? Wenn ja wird die Anzahl Mails 'rausgesucht. */
/*  if (((mailcount = get_mailcount(call)) == -1) && (rl == -1)) {
    strcpy(tmp,"213 Unknown.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }


  /* Nur nach rlfriends gucken, wenn readlock auf 2 steht, und es nicht unser eigenes
   * userfile ist.
   */
/*  if ((rl == 2) && (strcmp(call,child_udata.call))) {
    /* Readlock steht auf 2. Gucken, ob wir im rl-friends-Feld stehen. */
/*    ok = 0;
    while ((friends[0] != '\0') && !ok) {
      if ((i = POS(' ',friends)) == -1) {
        strcpy(tmp,friends);
        friends[0] = '\0';
      }
      else {
        COPY(tmp,friends,0,i);
        COPY(friends,friends,i+1,strlen(friends)-i-1);
      }
      
      if (!strcmp(tmp,child_udata.call)) ok = 1;
    }
    if (!ok) {
      strcpy(tmp,"212 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }
  
  strcpy(aktbox,call);
  sprintf(tmp,"214 Actual mailbox: %s. %i mails available.\n",aktbox,mailcount);
  write(child_fd,tmp,strlen(tmp));
  aktbox_readlock = rl;
}



void cmd_listbox(char *param)
{
  time_t rxtime;
  int fd,ready,akt,i,show,ans_long=FALSE;
  char tmp[500];
  s_index index;

  /* Gucken, ob der User berhaupt eingeloggt ist */
/*  if (!logged_in) {
    write(child_fd,str_must_login,strlen(str_must_login));
    return;
  }
  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';

  if (param[0] == '\0') {
    strcpy(tmp,"221 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  if ((i = POS(' ',param)) != -1) {
    COPY(tmp,param,i+1,strlen(param)-i-1);
    param[i] = '\0';
    
    Klein(tmp);
    if (!strcmp(tmp,"long"))
       ans_long = TRUE;
    else {
      strcpy(tmp,"221 Syntax error.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }


  rxtime = atol(param);
  
  /* Index-File fr das aktuelle Userfile ffnen */
/*  sprintf(tmp,"%s/index/%s.idx",boxroot,aktbox);
  if ((fd = open(tmp,O_RDONLY)) == -1) {
    /* Keine Mail vorhanden */
/*    strcpy(tmp,"222 New mail follow\n.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }


  strcpy(tmp,"222 New mail follow\n");
  write(child_fd,tmp,strlen(tmp));

  
  /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
/*  lockit(fd,F_RDLCK,0,SEEK_SET,0);
  

  akt = 1;
  ready = FALSE;
  
  while (!ready) {
    if (lseek(fd,-sizeof(s_index)*akt,SEEK_END) == -1) {
      /* Wir sind am Anfang des Files angelangt */
/*      ready = TRUE;
    }
    else {
      if (read(fd,&index,sizeof(s_index)) != sizeof(s_index)) {
        /* Fehler beim Lesen - sollte eigentlich nicht auftreten */
/*        ready = TRUE;
      }
      else {
        if (index.date < rxtime) {
          /* Da das indexfile zeitlich sortiert ist, kommen jetzt nur noch alte Mails */
/*          ready = TRUE;
        }
        else {
          show = FALSE;
          
          
          /* Jau, diese Mail ist neu. Gucken, nach readlock oder so
           * (Wenn Readlock == 2, dann stehen wir mit Sicherheit in rl-friends drin, da sonst aktbox nicht
           * gendert worden whre.
           */
/*          if ((aktbox_readlock == 0) || (aktbox_readlock == 2))
             show = TRUE;
          else
             if (!strcmp(aktbox,child_udata.call))
                show = TRUE;
             else
                if ((aktbox_readlock == 1) && ((index.flags & MAIL_READ) == MAIL_READ))
                   show = TRUE;
          
          /* Hold aktiv? */
/*          if ((index.flags & MAIL_HOLD) == MAIL_HOLD)
             if (strcmp(child_udata.call,index.sender) && ((child_udata.flags & UDATA_SYSOP) == 0)) show = FALSE;
          
          if (show == TRUE) {
            sprintf(tmp,"%s\n",index.bid);
            write(child_fd,tmp,strlen(tmp));
            if (ans_long) {
              if ((index.flags & MAIL_HOLD) == MAIL_HOLD)
                 sprintf(tmp," %s %s %s %i %i %i H\n %s\n",aktbox,index.mbx,index.sender,index.date,index.len,
                                                         index.lt,index.subject);
              else
                 sprintf(tmp," %s %s %s %i %i %i\n %s\n",aktbox,index.mbx,index.sender,index.date,index.len,
                                                         index.lt,index.subject);
              write(child_fd,tmp,strlen(tmp));
            }
          }
        }
      }
    }
    akt++;
  }
  
  
   /* File unlocken */
/*  lockit(fd,F_UNLCK,0,SEEK_SET,0);
  
  close(fd);

  /* Am Ende - '.' schicken */
/*  strcpy(tmp,".\n");
  write(child_fd,tmp,strlen(tmp));
}
*/



/* MYBBS-Call setzen */
void cmd_mybbs(char *param)
{
  time_t akttime;
  int i;
  char tmp[500];

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;


  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';

  if (param[0] == '\0') {
    strcpy(tmp,"511 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  Klein(param);
  param[9] = '\0';
  strcpy(child_udata.mybbs,param);
  child_udata.lastmybbs = time(NULL);
  WriteUserData(&child_udata);
  
  sprintf(tmp,"512 OK, MYBBS set to %s (%i).\n",child_udata.mybbs,child_udata.lastmybbs);
  write(child_fd,tmp,strlen(tmp));
}



void cmd_readlock(char *param)
{
  int i,rl;
  char tmp[500];

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;


  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';

  if (param[0] == '\0') {
    strcpy(tmp,"521 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  rl = atoi(param);
  if ((rl > 2) || (rl < 0)) {
    strcpy(tmp,"522 Wrong value.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  child_udata.readlock = rl;
  WriteUserData(&child_udata);
  
  sprintf(tmp,"523 OK, Readlock set to %i.\n",child_udata.readlock);
  write(child_fd,tmp,strlen(tmp));
}




void cmd_msg(char *param)
{
  int i,fd;
  char tmp[500];
  pid_t pid;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;


  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';

  if ((i = POS(' ',param)) == -1) {
    sprintf(tmp,"531 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  
  pid = atol(tmp);
  
  sprintf(tmp,"%s/userdata/%i.pid",boxroot,pid);
  if (!file_exist(tmp)) {
    sprintf(tmp,"532 PID %i is not available.\n",pid);
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  sprintf(tmp,"%s/userdata/%i.msg",boxroot,pid);
  if ((fd = open(tmp,O_APPEND|O_CREAT|O_WRONLY)) == -1) {
    sprintf(tmp,"533 Failure while sending.\n",pid);
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  /* File zum schreiben locken - Lesezugriffe sind nicht mehr mglich */
  lockit(fd,F_WRLCK,0,SEEK_SET,0);

  fchmod(fd,(S_IRUSR|S_IWUSR));


  sprintf(tmp,"%i (%s): %s\n",getpid(),child_udata.call,param);

  write(fd,tmp,strlen(tmp));  

  /* File unlocken */
  lockit(fd,F_UNLCK,0,SEEK_SET,0);

  close(fd);  


  strcpy(tmp,"534 OK, message sent.\n");
  write(child_fd,tmp,strlen(tmp));
}




/* Eine Usermail anhand ihrer BID auslesen */
/*void cmd_getbox(char *bid)
{
  int fd,count;
  char tmp[500];
  char rubrik[9],absender[9];
  int i,show,found;
  s_index index;
  unsigned long flags;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
/*  global_command_tests();
  
  if ((i = POS('\n',bid)) != -1) bid[i] = '\0';
  if ((i = POS('\r',bid)) != -1) bid[i] = '\0';
  
  
  if (bid[0] == '\0') {
    strcpy(tmp,"231 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  
  /* Gucken, ob der User diese Mail berhaupt lesen darf */#
/*  sprintf(tmp,"%s/index/%s.idx",boxroot,aktbox);
  if ((fd = open(tmp,O_RDONLY)) == -1) {
    sprintf(tmp,"232 Unknown BID %s.\n",bid);
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
/*  lockit(fd,F_RDLCK,0,SEEK_SET,0);

  
  /* BID in diesem Index-File suchen */
/*  found = FALSE;
  while (!found && ((count = read(fd,&index,sizeof(s_index))) == sizeof(s_index))) {
    if (!strcmp(bid,index.bid)) {
      found = TRUE;
      flags = index.flags;
      strcpy(absender,index.sender);
    }
  }
  
  /* File unlocken */
/*  lockit(fd,F_UNLCK,0,SEEK_SET,0);
  
  close(fd);
  
  if (!found) {
    sprintf(tmp,"232 Unknown BID %s.\n",bid);
    write(child_fd,tmp,strlen(tmp));
    return;
  }




  /* Jau, diese Mail ist vorhanden. Gucken, nach readlock oder so
   * (Wenn Readlock == 2, dann stehen wir mit Sicherheit in rl-friends drin, da sonst aktbox nicht
   * gendert worden whre.
   */
/*  show = FALSE;
  if ((aktbox_readlock == 0) || (aktbox_readlock == 2))
     show = TRUE;
  else
     if (!strcmp(aktbox,child_udata.call))
        show = TRUE;
     else
        if ((aktbox_readlock == 1) && ((flags & MAIL_READ) == MAIL_READ))
           show = TRUE;

  /* Hold aktiv? */
/*  if ((flags & MAIL_HOLD) == MAIL_HOLD)
     if (strcmp(child_udata.call,index.sender) && ((child_udata.flags & UDATA_SYSOP) == 0)) show = FALSE;


  if (!show) {
    strcpy(tmp,"234 Sorry, access denied.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }



  sprintf(tmp,"%s/user/%s/%s",boxroot,aktbox,bid);
  if ((fd = open(tmp,O_RDONLY)) == -1) {
    strcpy(tmp,"235 Datafile not available\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  else {
  
    /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
/*    lockit(fd,F_RDLCK,0,SEEK_SET,0);
    
    sprintf(tmp,"233 BID %s follows:\n",bid);
    write(child_fd,tmp,strlen(tmp));
    
    while ((count = read(fd,tmp,500)) != 0)
        write(child_fd,tmp,count);
    
    /* File unlocken */
/*    lockit(fd,F_UNLCK,0,SEEK_SET,0);
    
    close(fd);
    
    strcpy(tmp,"\n.\n");
    write(child_fd,tmp,strlen(tmp));
  }
  
  /* Hier wird irgendwann der Eintrag in die "Read:" - Zeile gemacht... Mal gucken, wann ich
   * dazu komme.
   */
/*}
*/



/* Gibt eine Liste der bekannten Boards mit Lifetimeangabe zurck. */
void cmd_boardlist()
{
  DIR *dp;
  struct dirent *dirp;
  char tmp[500],rubrik[9];
  int i,usermail,count,lt,found,maxlt;
  
  sprintf(tmp,"%s/index",boxroot);
  if ((dp = opendir(tmp)) == NULL) {
    strcpy(tmp,"541 Error! (opendir)\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  sprintf(tmp,"542 Boardlist follow:\n");
  write(child_fd,tmp,strlen(tmp));
  
  while ((dirp = readdir(dp)) != NULL) {
    strcpy(tmp,dirp->d_name);
    if ((i = POS('.',tmp)) != -1) tmp[i] = '\0';
    tmp[9] = '\0';
    strcpy(rubrik,tmp);
    
    if (rubrik[0] != '\0') {
      if (rufz(rubrik))
         usermail = TRUE;
      else
         usermail = FALSE;
      
      count = get_mailcount(rubrik);
      found = get_boardinfo(rubrik,&lt,&maxlt,tmp);
      
      if (found)
         if (usermail)
            sprintf(tmp,"%s u %i %i %i\n",rubrik,count,lt,maxlt);
         else
            sprintf(tmp,"%s b %i %i %i\n",rubrik,count,lt,lt);
      else
         if (usermail)
            sprintf(tmp,"%s u %i\n",rubrik,count);
         else
            sprintf(tmp,"%s b %i\n",rubrik,count);
      
      write(child_fd,tmp,strlen(tmp));
    }
  }

  closedir(dp);
  
  strcpy(tmp,".\n");
  write(child_fd,tmp,strlen(tmp));
}





/* Informationen ber die angegebene Station ausgeben */
void cmd_getinfo(char *call)
{
  int i;
  s_udata udata;
  char tmp[500];
  
  call[9] = '\0';
  
  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;
  
  
  if ((i = POS('\n',call)) != -1) call[i] = '\0';
  if ((i = POS('\r',call)) != -1) call[i] = '\0';
  
  
  if (call[0] == '\0') {
    strcpy(tmp,"551 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  strcpy(udata.call,call);
  if (!GetUserData(&udata)) {
    strcpy(tmp,"552 User unknown.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }


  sprintf(tmp,"553 Userinfo for %s:\n",call);
  write(child_fd,tmp,strlen(tmp));
  
  
  sprintf(tmp,"mybbs %s\n",udata.mybbs);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"lastmybbs %i\n",udata.lastmybbs);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"lastlogin %i\n",udata.lastlogin);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"name %s\n",udata.name);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"lastquit %i\n",udata.lastquit);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"readlock %i\n",udata.readlock);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"rlfriends %s\n",udata.friends);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"anzsend %i\n",udata.anzsend);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"anzread %i\n",udata.anzread);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"anzrec %i\n",udata.anzrec);
  write(child_fd,tmp,strlen(tmp));
  sprintf(tmp,"anzlogins %i\n",udata.anzlogins);
  write(child_fd,tmp,strlen(tmp));
  

  
  strcpy(tmp,".\n");
  write(child_fd,tmp,strlen(tmp));
}





/* Den eigenen Namen setzen - wird beim Mail verschicken bentigt. */
void cmd_name(char *param)
{
  int i;
  char tmp[500];

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;
  
  
  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';

  if (param[0] == '\0') {
    strcpy(tmp,"561 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  param[21] = '\0';
  strcpy(child_udata.name,param);
  WriteUserData(&child_udata);
  
  sprintf(tmp,"562 Name set to %s.\n",child_udata.name);
  write(child_fd,tmp,strlen(tmp));
}




/* Liest die Nachricht mit der bergebenen Nummer aus, und gibt sie aus. Das Format ist das selbe
 * wie beim GETMAIL-Befehl.
 */
void cmd_read(char *param)
{
  int i,nr,fd,ispos,wantpos,count,show,rl;
  char tmp[500],filename[500];
  char rubrik[9];
  s_index index;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;

  
  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';
  
  if ((i = POS(' ',param)) == -1) {
    strcpy(tmp,"301 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  COPY(tmp,param,0,i);
  tmp[9] = '\0';
  strcpy(rubrik,tmp);
  COPY(param,param,i+1,strlen(param)-i-1);
  nr = atoi(param);
  
  Klein(rubrik);
  
  sprintf(tmp,"%s/index/%s.idx",boxroot,rubrik);
  if ((fd = open(tmp,O_RDONLY)) == -1) {
    strcpy(tmp,"302 Unknown board.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
  lockit(fd,F_RDLCK,0,SEEK_SET,0);


  wantpos = (nr-1)*sizeof(s_index);
  ispos = lseek(fd,wantpos,SEEK_SET);
  
  if (ispos != wantpos) {
    strcpy(tmp,"303 Unknown mailnumber.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  if ((count = read(fd,&index,sizeof(index))) != sizeof(index)) {
    strcpy(tmp,"303 Unknown mailnumber.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  /* File unlocken */
  lockit(fd,F_UNLCK,0,SEEK_SET,0);
  close(fd);


  if ((index.flags & MAIL_USER) == MAIL_USER) {
    rl = get_readlock(rubrik,NULL);
    if (!readpermission(index.flags,rubrik,rl)) {
      strcpy(tmp,"306 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }
  else rl = 0;


  show = FALSE;

  /* (Wenn Readlock == 2, dann stehen wir mit Sicherheit in rl-friends drin, sonst whren wir schon bei
   * get_readlock() 'rausgeflogen.
   */
  if ((rl == 0) || (rl == 2))
     show = TRUE;
  else
     if (!strcmp(rubrik,child_udata.call))	/* Eigenes Fach? */
        show = TRUE;
     else
        if ((rl == 1) && ((index.flags & MAIL_READ) == MAIL_READ))
           show = TRUE;
  
  
  /* Hold aktiv? */
  if ((index.flags & MAIL_HOLD) == MAIL_HOLD)
      if (strcmp(child_udata.call,index.sender) && ((child_udata.flags & UDATA_SYSOP) == 0)) show = FALSE;

  if (show) {


    if ((index.flags & MAIL_USER) == MAIL_USER)
       sprintf(filename,"%s/user/%s/%s",boxroot,rubrik,index.bid);
    else
       sprintf(filename,"%s/info/%s/%s",boxroot,rubrik,index.bid);


    if ((fd = open(filename,O_RDONLY)) == -1) {
      strcpy(tmp,"304 Datafile not available.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }

    /* Gucken, ob die Mail gelscht wurde */
    if ((index.flags & MAIL_DEL) == MAIL_DEL) {
      /* Ja - Fehlermeldung */
      strcpy(tmp,"307 Mail is deleted.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }


    /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
    lockit(fd,F_RDLCK,0,SEEK_SET,0);

    strcpy(tmp,"305 OK, Mail follows:\n");
    write(child_fd,tmp,strlen(tmp));

    /* ReadCount-Zeile ausgeben */
    sprintf(tmp,"Readcount: %i\n",index.read);
    write(child_fd,tmp,strlen(tmp));

    while ((count = read(fd,tmp,500)) != 0)
        write(child_fd,tmp,count);

    /* Lese-Zhler um 1 erhhen */
    inc_readcount(index.bid,rubrik);

    /* Rufzeichen in die Readzeile anhngen */
    add_readlist(filename,child_udata.call);


    /* File unlocken */
    lockit(fd,F_UNLCK,0,SEEK_SET,0);

    close(fd);

    strcpy(tmp,".\n");
    write(child_fd,tmp,strlen(tmp));
  }
  else {
    sprintf(tmp,"306 Sorry, access denied.\n");
    write(child_fd,tmp,strlen(tmp));
  }
}




void cmd_list(char *param)
{
  int i,von,bis,fd,count,failure=FALSE,ok,rl;
  char tmp[500];
  char rubrik[9],friends[100];
  s_index index;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;

  
  if ((i = POS('\n',param)) != -1) param[i] = '\0';
  if ((i = POS('\r',param)) != -1) param[i] = '\0';
  
  if ((i = POS(' ',param)) == -1) {
    strcpy(tmp,"311 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  COPY(tmp,param,0,i);
  tmp[9] = '\0';
  strcpy(rubrik,tmp);
  Klein(rubrik);
  COPY(param,param,i+1,strlen(param)-i-1);

  if ((i = POS(' ',param)) == -1) {
    strcpy(tmp,"311 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);

  von = atoi(tmp);
  bis = atoi(param);  

  if (von > bis) {
    strcpy(tmp,"311 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  /********************** Gucken, ob diese Rubrik berhaupt gelesen werden darf ****************************/
  /* Hat die Station ein readlock gesetzt? */
  rl = get_readlock(rubrik,friends);

  /* Existiert denn das zugehrige Index-File? Wenn ja wird die Anzahl Mails 'rausgesucht. */
  sprintf(tmp,"%s/index/%s.idx",boxroot,rubrik);
  if (!file_exist(tmp) && (rl == -1)) {
    strcpy(tmp,"312 Unknown board.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }


  /* Nur nach rlfriends gucken, wenn readlock auf 2 steht, es nicht unser eigenes
   * userfile ist und wir nicht als SysOp eingeloggt sind.
   */
  if ((rl == 2) && (strcmp(rubrik,child_udata.call)) && ((child_udata.flags & UDATA_SYSOP) != UDATA_SYSOP)) {
    /* Readlock steht auf 2. Gucken, ob wir im rl-friends-Feld stehen. */
    ok = 0;
    while ((friends[0] != '\0') && !ok) {
      if ((i = POS(' ',friends)) == -1) {
        strcpy(tmp,friends);
        friends[0] = '\0';
      }
      else {
        COPY(tmp,friends,0,i);
        COPY(friends,friends,i+1,strlen(friends)-i-1);
      }
      
      if (!strcmp(tmp,child_udata.call)) ok = 1;
    }
    if (!ok) {
      strcpy(tmp,"313 Sorry, access denied.\n");
      write(child_fd,tmp,strlen(tmp));
      return;
    }
  }
  
  
  /* Wenn das eine Einbuchstabenrubrik ist und wir kein SysOp sind, kommt ne Fehlermeldung */
  if ((strlen(rubrik) == 1) && ((child_udata.flags & UDATA_SYSOP) == 0)) {
    strcpy(tmp,"313 Sorry, access denied.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  
  sprintf(tmp,"%s/index/%s.idx",boxroot,rubrik);
  if ((fd = open(tmp,O_RDONLY)) == -1) {
    strcpy(tmp,"312 Unknown board.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  sprintf(tmp,"314 OK, list %s from %i to %i.\n",rubrik,von,bis);
  write(child_fd,tmp,strlen(tmp));

  /* File zum lesen locken - Schreibzugriffe sind nicht mehr mglich */
  lockit(fd,F_RDLCK,0,SEEK_SET,0);

  i = von;
  while ((i <= bis) && !failure) {
  
    lseek(fd,(i-1)*sizeof(s_index),SEEK_SET);
    count = read(fd,&index,sizeof(s_index));
    if (count != sizeof(s_index))
       failure = TRUE;
    else {
    
      /* Wenn Readlock != 0 ist, gucken, ob wir diese aktuelle Mail angucken drfen. */
      if (rl != 0) {
        ok = FALSE;
        
        /* Die Mail ist eine ffentliche -> Anzeigen */
        if ((index.flags & MAIL_USER) == 0) ok = TRUE;
        else
        
        /* Wir sind als SysOp eingeloggt. */
        if ((child_udata.flags & UDATA_SYSOP) == UDATA_SYSOP) ok = TRUE;
        else
        
        /* Uns gehrt die Rubrik */
        if (!strcmp(rubrik,child_udata.call)) ok = TRUE;
        else
        
        /* Die Mail wurde schon gelesen und rl steht auf 1 */
        if ((rl == 1) && ((index.flags & MAIL_READ) == MAIL_READ)) ok = TRUE;
      }
      else ok = TRUE;
    
      /* Hold aktiv? */
      if ((index.flags & MAIL_HOLD) == MAIL_HOLD)
         if (strcmp(child_udata.call,index.sender) && ((child_udata.flags & UDATA_SYSOP) == 0)) ok = FALSE;

      /* Wenn die Mail gelscht ist, darf sie niemand sehen */    
      if ((index.flags & MAIL_DEL) == MAIL_DEL) ok = FALSE;
    
      if (ok) {
        sprintf(tmp,"%s\n",index.bid);
        write(child_fd,tmp,strlen(tmp));
        sprintf(tmp," %s %s %s %i %i %i %i\n",rubrik,index.mbx,index.sender,index.date,index.len,
                                              index.lt,i);
        write(child_fd,tmp,strlen(tmp));
        sprintf(tmp," %s\n",index.subject);
        write(child_fd,tmp,strlen(tmp));
      }
    }
  
    i++;
  }

  /* File unlocken */
  lockit(fd,F_UNLCK,0,SEEK_SET,0);
  close(fd);

  strcpy(tmp,".\n");
  write(child_fd,tmp,strlen(tmp));
}





/* Zeigt Informationen zu Stationen an, die ebenfalls eingeloggt sind. */
void cmd_showlogins()
{
  struct dirent *entry;
  DIR *dir;
  char tmp[500],tmp2[500],call[10];
  int i,ok;
  pid_t ppid,pid;
  FILE *fs;
  time_t login;
  
  sprintf(tmp,"%s/userdata/",boxroot);
  if ((dir = opendir(tmp)) == NULL) {
    strcpy(tmp,"572 Error.\n");
    write(child_fd,tmp,strlen(tmp));
  }
  
  /* pid des parent-prozesses holen */
  ppid = getppid();
  
  strcpy(tmp,"571 Users:\n");
  write(child_fd,tmp,strlen(tmp));
  
  while ((entry = readdir(dir)) != NULL) {
  
    /* Gucken, ob die letzten 4 Zeichen ".pid" sind. */
    COPY(tmp,entry->d_name,strlen(entry->d_name)-4,4);
    if (!strcmp(tmp,".pid")) {
    
      /* Die PID nach pid schreiben */
      COPY(tmp,entry->d_name,0,sizeof(entry->d_name)-4);
      pid = atoi(tmp);
      
      call[0] = '\0';
      login = -1;
      ok = FALSE;
      
      sprintf(tmp,"%s/userdata/%s",boxroot,entry->d_name);
      if ((fs = fopen(tmp,"r")) != NULL) {
        while (fgets(tmp,100,fs) != NULL) {
          if ((i = POS('\n',tmp)) != 1) tmp[i] = '\0';

          if ((i = POS(' ',tmp)) != -1) {
            COPY(tmp2,tmp,0,i);
            COPY(tmp,tmp,i+1,strlen(tmp)-i-1);
            KillSpacesLeft(tmp);
            
            if (!strcmp(tmp2,"parent"))
               if (atoi(tmp) == ppid) ok = TRUE;
            if (!strcmp(tmp2,"call"))
               strcpy(call,tmp);
            if (!strcmp(tmp2,"logintime"))
               login = atoi(tmp);
          }
        }
      }
      fclose(fs);
      
      if (ok) {
        /* Diese PID gehrt zu unserem Elternprozess */
        if (call[0] == '\0') strcpy(call,"unknown");
        sprintf(tmp,"%6i  %8s  %i\n",pid,call,login);
        write(child_fd,tmp,strlen(tmp));
      }
      else {
        /* Nicht unser Elternprozess also ein lteres PID-File, das aus irgend einem Grund nicht gelscht
         * wurde.
         */
        sprintf(tmp,"%s/userdata/%s",boxroot,entry->d_name);
        unlink(tmp);
      }
    }
  }
  
  closedir(dir);

  strcpy(tmp,".\n");
  write(child_fd,tmp,strlen(tmp));

}








/* Put-Befehl fr die Mailbox */
void cmd_put(char *param)
{
  char rubrik[10];
  char mbx[10];
  char sender[10];
  char typ[2];
  int lt,i,getlen=0,len=0,usermail,len_got=0,fd,count,ende=0,idxnr,maxlt;
  char tmp[500],tmp2[500];
  char bid[13],subject[81];
  time_t tnow;
  struct tm gm_tnow;
  s_check checkdata;
  s_index indexdata;
  char transfer_rubrik[9];
  int new_lt,transfer=FALSE;
  
  char str_put_error[] = "161 Syntax error.\n";
  bid[0] = '\0';
  
  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;

  
  if (!is_sf_user()) {
    strcpy(tmp,"165 Sorry, access denied.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  if ((i = POS(' ',param)) == -1) {
    write(child_fd,str_put_error,strlen(str_put_error));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  tmp[10] = '\0';
  strcpy(sender,tmp);
  Klein(sender);
  
  if ((i = POS(' ',param)) == -1) {
    write(child_fd,str_put_error,strlen(str_put_error));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  tmp[14] = '\0';
  strcpy(bid,tmp);
  if ((i = POS(' ',param)) == -1) {
    write(child_fd,str_put_error,strlen(str_put_error));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  typ[0] = tmp[0];
  typ[1] = '\0';
  Gross(typ);
  
  if ((typ[0] != 'P') && (typ[0] != 'B') && (typ[0] != 'A')) {
    strcpy(tmp,"168 Wrong filetype.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }

  if ((i = POS(' ',param)) == -1) {
    write(child_fd,str_put_error,strlen(str_put_error));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  tmp[10] = '\0';
  strcpy(rubrik,tmp);
  
  if ((i = POS(' ',param)) == -1) {
    write(child_fd,str_put_error,strlen(str_put_error));
    return;
  }
  COPY(tmp,param,0,i);
  COPY(param,param,i+1,strlen(param)-i-1);
  tmp[10] = '\0';
  strcpy(mbx,tmp);

  Klein(rubrik);
  Klein(mbx);


  if ((i = POS(' ',param)) == -1) {
    /* Nur Lifetime */
    lt = atoi(param);
  }
  else {
    getlen = 1;
    COPY(tmp,param,0,i);
    COPY(param,param,i+1,strlen(param)-i-1);
    
    lt = atoi(tmp);
    len = atoi(param);
  }
  
  /* Fr diese Mail eine neue BID erzeugen */
  if (bid[0] == '?') {
    NewBID(bid);
    Gross(bid);
  }


  /* Kommt da eine Usermail? */
  if (typ[0] == 'P') usermail = TRUE;

  if (!strcmp(mbx,"?")) {
    /* Kein Verteiler bekannt. Bei Pub-Mails den Standardverteiler, bei Usermails das MYBBS
     * 'raussuchen.
     */
    if (usermail) {
      if (!get_mybbs(rubrik,mbx)) {
        /* Das bergebene Rufzeichen ist unbekannt */
        strcpy(tmp,"167 Unknown destination-box.\n");
        write(child_fd,tmp,strlen(tmp));
        return;
      }
      Klein(mbx);
    }
    else {
      /* Der Verteiler ist die eigene Mailbox. */
      strcpy(mbx,mycall);
      Klein(mbx);
    }
  }



  /* Nur in boards.box gucken, wenn es ein Bulletin ist. */
  if (!usermail) {
    /* Gucken, ob diese Mail evtl. im boards.box - File steht (transfer) */
    if (get_boardinfo(rubrik,&new_lt,&maxlt,transfer_rubrik)) {
      /* Ja, vorhanden. Nach der Lifetime gucken */
      if (lt == -1) lt = new_lt;
      if (lt > (maxlt)) lt = maxlt;
    
      /* Transfer */
      strcpy(rubrik,transfer_rubrik);
    }
    else {
      /* Nicht vorhanden im boards.box - File */
      if (lt == -1) lt = stdlt;
    }
  }
  else {
    if (lt == -1) lt = userlt;
    if (lt > userlt) lt = userlt;
  }


  
  /* Gucken, ob das Datenverzeichnis fr diese Rubrik schon existiert */
  if (usermail)
     sprintf(tmp,"%s/user/%s",boxroot,rubrik);
  else
     sprintf(tmp,"%s/info/%s",boxroot,rubrik);
  if (mkdir(tmp,448) == -1) { }
  
  /* File ffnen. */
  sprintf(tmp,"%s/%s",tmp,bid);
  fd = open(tmp,(O_WRONLY|O_CREAT));
  fchmod(fd,(S_IRUSR|S_IWUSR));
  
  strcpy(tmp,"162 Waiting for the subject.\n");
  write(child_fd,tmp,strlen(tmp));
  
  
  /* Warten auf das Subject */
  count = child_getline(tmp,sizeof(tmp));
  tmp[81] = '\0';
  strcpy(subject,tmp);
  if ((i = POS('\n',subject)) != -1) subject[i] = '\0';
  if ((i = POS('\r',subject)) != -1) subject[i] = '\0';
  
  /* "RFC"-Header in das File schreiben */
  sprintf(tmp,"Path: %s\n",mycall);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Read: %256c\n",' ');
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"From: %s\n",sender);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"To: %s@%s\n",rubrik,mbx);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Subject: %s\n",subject);
  write(fd,tmp,strlen(tmp));
  
  tnow = time(NULL);
  gm_tnow = *gmtime(&tnow);
  sprintf(tmp,"Date: %i %s %i %.2i:%.2i:%.2i\n",gm_tnow.tm_mday,monate[gm_tnow.tm_mon],gm_tnow.tm_year+1900,
                                              gm_tnow.tm_hour,gm_tnow.tm_min,gm_tnow.tm_sec);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Message-ID: %s\n",bid);
  write(fd,tmp,strlen(tmp));
  sprintf(tmp,"Lifetime: %i\n",lt);
  write(fd,tmp,strlen(tmp));

  /* Sooo - jetzt mit einem \n getrennt kommt der aus dem Amateurfunk bekannte header */
  if (typ[0] != 'A') {
    sprintf(tmp,"\n");
    sprintf(tmp2,"%s%s",mycall,myhierarch);
    Gross(tmp2);
    write(fd,tmp,strlen(tmp));
    sprintf(tmp,"R:%.2i%.2i%.2i/%.2i%.2iZ @:%s [%s] vjboxd-%i.%i\n",
               gm_tnow.tm_year,gm_tnow.tm_mon+1,gm_tnow.tm_mday,gm_tnow.tm_hour,gm_tnow.tm_min,
               tmp2,sfinfo,MAJORLEVEL,MINORLEVEL);
    write(fd,tmp,strlen(tmp));
  }
  

  /* Dem Frontend bescheid sagen, da empfangen wird */
  if (getlen)
     sprintf(tmp,"164 OK, waiting for %i bytes.\n",len);
  else
     sprintf(tmp,"163 OK, end with a single dot.\n");
  write(child_fd,tmp,strlen(tmp));
  ende = 0;
  
  while (!ende) {
    count = child_getline(tmp,sizeof(tmp));
    tmp[81] = '\0';
    
    if (getlen) {
      if (len_got+count <= len) {
        write(fd,tmp,count);
        len_got = len_got + count;
      }
      else {
        ende = 1;
        write(fd,tmp,len-len_got);
      }
      
    }
    else {
      if ((count <= 3) && (tmp[0] == '.'))
         ende = 1;
      else {
        write(fd,tmp,count);
        len = len + count;
      }
    }
  }
  
  
  close(fd);
  
  /* Den Eintrag ins Index-File machen */
  strcpy(indexdata.mbx,mbx);
  strcpy(indexdata.sender,sender);
  indexdata.date = tnow;
  indexdata.len = len;
  indexdata.lt = lt;
  indexdata.read = 0;
  strcpy(indexdata.bid,bid);
  strcpy(indexdata.subject,subject);
  if (!usermail)
     indexdata.flags = 0;
  else
     indexdata.flags = MAIL_USER;
  switch (forw_hold_this_msg(indexdata.sender,rubrik,indexdata.mbx,indexdata.len,usermail)) {
    case 1: /* HOLD */
            indexdata.flags |= MAIL_HOLD;
            break;
    case 2: /* REJECT */
            break;
  }
  idxnr = write_index(&indexdata,rubrik);
  
  /* Den Eintrag in die Checkliste machen */
  strcpy(checkdata.rubrik,rubrik);
  strcpy(checkdata.mbx,mbx);
  strcpy(checkdata.sender,sender);
  checkdata.date = indexdata.date;
  checkdata.len = indexdata.len;
  checkdata.lt = indexdata.lt;
  checkdata.flags = indexdata.flags;
  checkdata.nr = idxnr;
  checkdata.read = 0;			/* Anzahl Read-Zugriffe auf diese Mail */
  strcpy(checkdata.bid,bid);
  strcpy(checkdata.subject,subject);
  write_checklist(&checkdata);
  
  
  /* diese BID zur BID-Liste dazu */
  add_bidlist(bid);

  /* Sendet diese (neue) BID in Richtung Router */
  router_sendbid_fifo(bid);
  
  /* anzsend++ */
/*  child_udata.anzsend++;
  WriteUserData(&child_udata);*/
  
  sprintf(tmp,"166 OK, file saved.\n");
  write(child_fd,tmp,strlen(tmp));
}




/* Guckt, ob das bergebene Call von der vjbox als gltig anerkannt wird. */
void cmd_callvalid(char *param)
{
  char tmp[100];

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;
  
  Klein(param);
  
  if (rufz(param))
     strcpy(tmp,"591 YES\n");
  else
     strcpy(tmp,"592 NO\n");
  write(child_fd,tmp,strlen(tmp));
}



/* Eine Mail als Gelscht markieren (sucht nach einer BID) */
void cmd_deletebid(char *param)
{
  int fd;
  char tmp[500];
  int ok=FALSE;
  s_check check;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;

  if (getinfo_bid(param,&check) == 0) {
    sprintf(tmp,"173 BID %s is not known.\n",param);
    write(child_fd,tmp,strlen(tmp));
    return;
  }


  /* Gucken, ob die Mail gelscht werden darf.
   *
   * Lschen darf sie der SysOp, der Empfnger und der Absender.
   */
  if ((child_udata.flags & UDATA_SYSOP) == UDATA_SYSOP) ok = TRUE;	/* SysOp */
  else
  if (!strcmp(check.sender,child_udata.call)) ok = TRUE;		/* Absender */
  else
  if (!strcmp(check.rubrik,child_udata.call)) ok = TRUE;		/* Empfnger */

  if (ok) {
  
    /* Gucken, ob die Mail schon als gelscht markier ist */
    if ((check.flags & MAIL_DEL) == MAIL_DEL)
       sprintf(tmp,"174 BID %s is allready deleted.\n",check.bid);
    else
    {
      /* Mail wirklich als Gelscht markieren */
      delete_bid(check.bid);
      delete_nr(check.rubrik,check.nr);
      strcpy(tmp,"171 OK, deleted.\n");
    }
  }
  else strcpy(tmp,"172 Sorry, access denied\n");
  
  write(child_fd,tmp,strlen(tmp));
}



/* Zum Auslesen/Verndern von Konfigurationsdateien - SYSOP ONLY */
void cmd_config(char *param)
{
  char tmp[500],tmp2[500];
  char filename[500],key[500],wert[500];
  int i;

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;


  /* Nur, wenn SysOp */
/*  if ((child_udata.flags & UDATA_SYSOP) == 0) {
    strcpy(tmp,"601 Sorry, access denied.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }*/
  
  /* Gucken, ob die Syntax richtig ist. (Parameterstring zerflcken) */
  OnlyOneSpace(tmp,param);
  KillSpacesRight(tmp);
  KillSpacesLeft(tmp);
  
  i = sscanf(tmp,"%s %s %s",filename,key,wert);
  
  if (i < 2)
  {
    strcpy(tmp,"603 Syntax error.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
  
  
  
  sprintf(tmp,"filename: %s\nkey: %s\n",filename,key);
  write(child_fd,tmp,strlen(tmp));


}


/* Nimmt die bergebene Nachricht aus dem HOLD - Paramter: <bid> - SYSOP ONLY*/
void cmd_release(char *param)
{
  char tmp[500];

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;

  /* SysOp only */
  if ((child_udata.flags & UDATA_SYSOP) != UDATA_SYSOP) {
    strcpy(tmp,"581 Sorry, access denied.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }
  
}




/* Zeigt eine Liste der Mails an, die im Augenblick im Hold liegen - SYSOP ONLY */
void cmd_showhold(char *param)
{
  char tmp[500];

  /*
   * Hier wird geguckt, ob die Station eingeloggt ist, und ob das Pass-Kommando benutzt
   * wurde.
   */
  if (!global_command_tests()) return;


  if ((child_udata.flags & UDATA_SYSOP) != UDATA_SYSOP) {
    strcpy(tmp,"115 Sorry, access denied.\n");
    write(child_fd,tmp,strlen(tmp));
    return;
  }


  
}



/* Guckt, ob die bergebene BID im BID-Pool enthalten ist */
void cmd_bidexist(char *bid)
{
  char tmp[40];

  if (bid_checkforbid(bid))
     strcpy(tmp,"401 BID exist.\n");
  else
     strcpy(tmp,"402 BID does not exist.\n");
  write(child_fd,tmp,strlen(tmp));
}




